$(document).ready(function () {
  function CommonMixin() {
    this.disableScaling(); //禁止双击放大
    //登录凭证
    this.tgt = this.GetQueryString('tgt') || window.OrderDist.getTgt();
    if (window.navigator.onLine !== true) {
      $(".loadingMask").addClass("none");
      $('.network_toast').html(`网络连接失败，请检查网络`).removeClass('none')
      setTimeout(()=>{
        $('.network_toast').addClass('none')
      },1500)
      return
    }
  }

  CommonMixin.prototype.isAndroid = function() {
    var u = navigator.userAgent;
    var isAndroid = u.indexOf('Android') > -1 || u.indexOf('Linux') > -1; //android终端或者uc浏览器
    // var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
    return isAndroid;
  }

  //获取Token
  CommonMixin.prototype.getToken = function (callback) {
    $.ajax({
      type: "POST",
      url: `https://vip.foxitreader.cn/v2/tokens/${this.tgt}`,
      xhrFields: {
        withCredentials: true, 
      },
      corssDomain: true,
      success: (res) => {
        const { ret, data } = res;
        if (ret === 0) {
          this.token = data.token;
          callback && callback();
          this.getUserInfo();
        } else {
          if(this.isAndroid()) {
            window.AndroidWebView.webViewClose();
          } else {
            window.webkit.messageHandlers.webViewClose.postMessage('');
          }
        }
      },
    });
  };

  //获取用户信息
  CommonMixin.prototype.getUserInfo = function () {
    $.ajax({
      type: "get",
      url: `https://vip.foxitreader.cn/v2/getUserVipInfo?token=${this.token}&platform=pc`,
      xhrFields: {
        withCredentials: true, 
      },
      jsonp: "jsonpcallback",
      dataType: "jsonp",
      success: (res) => {
        const { ret, data } = res;
        if (ret === 0 && data && data.vipInfo && data.vipInfo.userId) {
          if(localStorage.getItem(`invoiceRule_${data.vipInfo.userId}`)) return;
          localStorage.setItem(`invoiceRule_${data.vipInfo.userId}`, true);
          $(".rule_dialog, .mask").removeClass("none");
          $("body").addClass("hidden");
        }
      },
    });
  };

  //ios禁止双击放大
  CommonMixin.prototype.disableScaling = function () {
    document.addEventListener("touchstart", function (event) {
      if (event.touches.length > 1) {
        event.preventDefault();
      }
    });

    var lastTouchEnd = 0;

    document.addEventListener(
      "touchend",
      function (event) {
        var now = new Date().getTime();
        if (now - lastTouchEnd <= 300) {
          event.preventDefault();
        }
        lastTouchEnd = now;
      },
      false
    );

    document.addEventListener("gesturestart", function (event) {
      event.preventDefault();
    });
  };

  // url获取参数
  CommonMixin.prototype.GetQueryString = function (name) {
    let reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
    let r = window.location.search.substr(1).match(reg);
    if (r !== null) return unescape(r[2]);
    return "";
  };

  $.fn.extend({
    CommonMixinClass: new CommonMixin(),
  });
});
