$(document).ready(function () {

  function Index() {
    this.getOrders();
    this.even();
    if ($.fn.CommonMixinClass.isAndroid()) {
      window.OrderDist.refreshWebTitle("订单/发票");
    } else {
      window.webkit.messageHandlers.refreshWebTitle.postMessage({
        webTitle: "订单/发票",
      });
    }
    // 监视页面标签页是否处于激活状态
    window.addEventListener('visibilitychange', () => {
      $('.ruleBtn span').html(`进入visibilitychange`)
      if (document.visibilityState === 'visible') {
        $(".loadingMask").removeClass("none");
        this.getOrders();
        //监听网络链接丢失
        if (window.navigator.onLine !== true) {
          $(".loadingMask").addClass("none");
          return
        }
      }
    })
  }

  Index.prototype.getOrders = function() {
    //监听是否网络链接丢失
    if (window.navigator.onLine !== true) {
      $(".loadingMask").addClass("none");
      return
    }
    $.ajax({
      type: "GET",
      url: `https://vip.foxitreader.cn/v2/getUserOrders?status=2&pageNum=1&pageSize=0&orderCategory=Scanner&v=${Math.random()}`,
      xhrFields: {
        withCredentials: true, 
      },
      corssDomain: true,
      timeout:10000,
      data: {
        token: $.fn.CommonMixinClass.token,
        platform: "pc"
      },
      success: (res) => {
        const { ret, data } = res;
        if (ret === 0) {
          const templateData = data.list.map(item => {
            switch(item.invoice) {
              case 0:
                item.invoiceEnabled = true;
                break;
              case 1:
                item.isExpired = false;
                break;
              case 9:
                item.isExpired = true;
                break;
            }
            return item;
          })
          this.template(templateData);
          $(".loadingMask").addClass("none");
        } else {
          if($.fn.CommonMixinClass.isAndroid()) {
            window.AndroidWebView.webViewClose();
          } else {
            window.webkit.messageHandlers.webViewClose.postMessage('');
          }
        }
      },
      error:()=>{
        $(".loadingMask").addClass("none");
      }
    });
  }

  Index.prototype.template = function (data=[]) {
    let orders = null;
    if(data.length > 0) orders = data;
    let tpl = $("#myTemplate").html();
    let template = Handlebars.compile(tpl);
    let html = template(orders);
    $(".div_list").html(html);
  };

  //事件绑定
  Index.prototype.even = function () {
    
    $(".rule_dialog .btn").off().on("click", function() {
      $(".rule_dialog, .mask").addClass("none");
      $("body").removeClass("hidden");
    })

    $(".ruleBtn").off().on("click", function() {
      $(".rule_dialog, .mask").removeClass("none");
      $("body").addClass("hidden");
    })

    $(".div_list").off().on("click", ".request", function(e) {
      //断网处理
      if (window.navigator.onLine !== true) {
        $(".loadingMask").addClass("none");
        $('.network_toast').html(`网络连接失败，请检查网络`).removeClass('none')
        setTimeout(()=>{
          $('.network_toast').addClass('none')
        },1500)
        return
      }
      const orderId = $(e.target).attr("orderid");
      const orderSum = $(e.target).attr("money");
      if($(e.target).hasClass("isExpired")) return;
      if($(e.target).hasClass("hadInvoice")) {
        if($.fn.CommonMixinClass.isAndroid()) {
          window.location.href = `./order_invoicing.html?detail=1&orderId=${orderId}&invoiceMoney=${orderSum}&token=${$.fn.CommonMixinClass.token}`
        } else {
          window.location.href = `./order_invoicing.html?detail=1&orderId=${orderId}&invoiceMoney=${orderSum}&token=${$.fn.CommonMixinClass.token}`
        }
        return;
      }
      if($.fn.CommonMixinClass.isAndroid()) {
        window.location.href = `./order_invoicing.html?orderId=${orderId}&invoiceMoney=${orderSum}&token=${$.fn.CommonMixinClass.token}`
      } else {
        window.location.href = `./order_invoicing.html?orderId=${orderId}&invoiceMoney=${orderSum}&token=${$.fn.CommonMixinClass.token}`
      }
    })
  }

  $.fn.CommonMixinClass.getToken(() => {
    new Index();
  });
});
