$(document).ready(function () {
  function Index() {
    this.token = this.GetQueryString("token");
    this.form = {
      orderId: this.GetQueryString("orderId"),
      inStatus: 2,
      invoiceType: "增值税普通发票【个人】",
      invoiceBody: "技术服务费",
      invoiceTitle: "",
      taxpayerId: "",
      email: "",
      invoiceMoney: this.GetQueryString("invoiceMoney"),
    };
    this.initForm();
    this.disableScaling();
    this.even();
  }

  Index.prototype.isAndroid = function () {
    var u = navigator.userAgent;
    var isAndroid = u.indexOf("Android") > -1 || u.indexOf("Linux") > -1; //android终端或者uc浏览器
    return isAndroid;
  };

  Index.prototype.submitForm = function () {
    //断网处理
    if (window.navigator.onLine !== true) {
      $(".loadingMask").addClass("none");
      $('.network_toast').html(`网络连接失败，请检查网络`).removeClass('none')
      setTimeout(()=>{
        $('.network_toast').addClass('none')
      },1500)
      return
    }
    $(".loadingMask").removeClass("none");
    $.ajax({
      type: "POST",
      url: `https://vip.foxitreader.cn/v2/createInvoice?token=${this.token}&platform=pc`,
      xhrFields: {
        withCredentials: true,
      },
      corssDomain: true,
      data: this.form,
      success: (res) => {
        $(".loadingMask").addClass("none");
        const { ret } = res;
        if (ret === 0) {
          this.hideDialog(".confirmInfo");
          $(".form_container").addClass("none");
          $(".success_container").removeClass("none");
          if (this.isAndroid()) {
            window.OrderDist.refreshWebTitle("订单/发票");
          } else {
            window.webkit.messageHandlers.refreshWebTitle.postMessage({
              webTitle: "订单/发票",
            });
          }
        } else {
          $(".div_toast").html("申请失败, 请重试");
          $(".div_toast").removeClass("none");
          clearTimeout(this.timer);
          this.timer = setTimeout(() => {
            $(".div_toast").addClass("none");
          }, 1500);
        }
      },
      fail: () => {
        $(".loadingMask").addClass("none");
      },
    });
  };

  //ios禁止双击放大
  Index.prototype.disableScaling = function () {
    document.addEventListener("touchstart", function (event) {
      if (event.touches.length > 1) {
        event.preventDefault();
      }
    });

    var lastTouchEnd = 0;

    document.addEventListener(
      "touchend",
      function (event) {
        var now = new Date().getTime();
        if (now - lastTouchEnd <= 300) {
          event.preventDefault();
        }
        lastTouchEnd = now;
      },
      false
    );

    document.addEventListener("gesturestart", function (event) {
      event.preventDefault();
    });
  };

  // url获取参数
  Index.prototype.GetQueryString = function (name) {
    let reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
    let r = window.location.search.substr(1).match(reg);
    if (r !== null) return unescape(r[2]);
    return "";
  };

  // 初始化表单数据
  Index.prototype.initForm = function () {
    const invoiceMoney = this.GetQueryString("invoiceMoney");
    $(".value[field=invoiceMoney]").html(`${invoiceMoney}元`);
    $(".popupBottom[field=invoiceType]").find(".radio")[0].checked = true;
    $(".popupBottom[field=invoiceBody]").find(".radio")[0].checked = true;
    if (this.isAndroid()) {
      window.OrderDist.refreshWebTitle("申请开票");
    } else {
      window.webkit.messageHandlers.refreshWebTitle.postMessage({
        webTitle: "申请开票",
      });
    }
    if (this.GetQueryString("detail")) {
      this.getDetail();
    } else {
      $(".form_container").removeClass("none");
    }
  };

  // 获取详情
  Index.prototype.getDetail = function () {
    $.ajax({
      type: "GET",
      url: `https://vip.foxitreader.cn/v2/getInvoiceInfo?v=${Math.random()}`,
      xhrFields: {
        withCredentials: true,
      },
      corssDomain: true,
      data: {
        token: this.token,
        platform: "pc",
        orderId: this.GetQueryString("orderId"),
      },
      success: (res) => {
        const { ret, data } = res;
        if (ret === 0 && data) {
          this.form = data;
          this.showDetail();
        } else {
          if (this.isAndroid()) {
            window.AndroidWebView.webViewClose();
          } else {
            window.webkit.messageHandlers.webViewClose.postMessage("");
          }
        }
      },
    });
  };

  // 展示dialog
  Index.prototype.showDialog = function (className) {
    $(`${className},.mask`).removeClass("none");
    $("body").addClass("hidden");
  };

  // 隐藏dialog
  Index.prototype.hideDialog = function (className) {
    $(`${className},.mask`).addClass("none");
    $("body").removeClass("hidden");
  };

  Index.prototype.validator = function (el) {
    const field = el.attr("field");
    let value;
    if (field === "email") {
      value = el.val().trim();
    } else {
      value = el.val();
    }
    el.val(value);
    this.form[field] = value;
    // 隐藏错误提示
    el.parent(".formItem").removeClass("redBorder");
    el.parent().next().addClass("none");
    let errorText = "";
    switch (field) {
      case "invoiceTitle":
        if (
          !value ||
          !/^[0-9a-zA-Z\(\)\（\）\s\u4e00-\u9fa5]{0,50}$/.test(value)
        ) {
          errorText = "请输入正确的发票抬头";
        }
        break;
      case "taxpayerId":
        if (
          !/^[A-Z0-9]{15}$|^[A-Z0-9]{17}$|^[A-Z0-9]{18}$|^[A-Z0-9]{20}$/.test(
            value
          )
        ) {
          errorText = "请输入正确的纳税人识别号";
        }
        break;
      case "email":
        if (
          !/^[a-zA-Z0-9_.-]+@[a-zA-Z0-9-]+(\\.[a-zA-Z0-9-]+)*\.[a-zA-Z0-9]{2,6}$/.test(
            value
          )
        ) {
          errorText = "请输入正确的邮箱地址";
        }
        break;
    }
    if (errorText) {
      el.parent(".formItem").addClass("redBorder");
      el.parent().next().html(errorText);
      el.parent().next().removeClass("none");
    }
    return errorText;
  };

  Index.prototype.showDetail = function () {
    //断网处理
    if (window.navigator.onLine !== true) {
      $(".loadingMask").addClass("none");
      $('.network_toast').html(`网络连接失败，请检查网络`).removeClass('none')
      setTimeout(()=>{
        $('.network_toast').addClass('none')
      },1500)
      return
    }
    $(".success_container").addClass("none");
    document.title = "开票详情";
    if (this.isAndroid()) {
      window.OrderDist.refreshWebTitle("开票详情");
    } else {
      window.webkit.messageHandlers.refreshWebTitle.postMessage({
        webTitle: "开票详情",
      });
    }
    $(".div_form").html(`
      <div class="form">
          <div class="formItem">
            <label class="label ml0">抬头类型</label>
            <span class="value">${this.form["invoiceType"]}</span>
          </div>
          <div class="formItem">
            <label class="label ml0">发票抬头</label>
            <span class="value">${this.form["invoiceTitle"]}</span>
          </div>
          ${
            this.form["invoiceType"] !== "增值税普通发票【个人】"
              ? `<div class="formItem">
          <label class="label ml0">发票税号</label>
          <span class="value">${this.form["taxpayerId"]}</span>
        </div>`
              : ""
          }
          <div class="formItem">
            <label class="label ml0">发票类型</label>
            <span class="value">电子发票</span>
          </div>
          <div class="formItem">
            <label class="label ml0">发票内容</label>
            <span class="value">${this.form["invoiceBody"]}</span>
          </div>
          <div class="formItem">
            <label class="label ml0">开票金额</label>
            <span class="value">${this.form["invoiceMoney"]}元</span>
          </div>
        </div>
        <div class="form mt40">
          <div class="formItem ml0">
            <label class="label">邮箱地址</label>
            <span class="value">${this.form["email"]}</span>
          </div>
        </div>`);
    $(".detail_container").removeClass("none");
  };

  //事件绑定
  Index.prototype.even = function () {
    $(".mask").off().on("click", () => {
      $(".mask, .popupBottom,.dialog").addClass("none");
      $("body").removeClass("hidden");
    });

    $(".confirm")
      .off()
      .on("click", () => {
        this.submitForm();
      });

    $(".formItem[field=invoiceType]")
      .off()
      .on("click", (e) => {
        this.showDialog(".popupBottom[field=invoiceType]");
      });

    $(".formItem[field=invoiceBody]")
      .off()
      .on("click", (e) => {
        this.showDialog(".popupBottom[field=invoiceBody]");
      });

    $(".radio")
      .off()
      .on("click", (e) => {
        const field = $(e.target).attr("name");
        const value = $(e.target).attr("value");
        if (field === "invoiceType" && value !== "增值税普通发票【个人】") {
          $("input[field=taxpayerId]").parents(".formItem").removeClass("none");
          $("input[field=taxpayerId]")
            .parents(".formItem")
            .next()
            .removeClass("none");
        }
        if (field === "invoiceType" && value === "增值税普通发票【个人】") {
          this.form["taxpayerId"] = "";
          $("input[field=taxpayerId]").val("");
          $("input[field=taxpayerId]").parents(".formItem").next().html("");
          $("input[field=taxpayerId]").parents(".formItem").addClass("none");
          $("input[field=taxpayerId]")
            .parents(".formItem")
            .next()
            .addClass("none");
          $("input[field=taxpayerId]")
            .parents(".formItem")
            .removeClass("redBorder");
        }
        this.form[field] = value;
        $(`.value[field=${field}]`).html(value);
      });
    $(".btnBox .btn_detail")
      .off()
      .on("click", (e) => {
        this.showDetail();
      });

    $(".btnBox .btn")
      .off()
      .on("click", (e) => {
         //断网处理
        if (window.navigator.onLine !== true) {
          $(".loadingMask").addClass("none");
          $('.network_toast').html(`网络连接失败，请检查网络`).removeClass('none')
          setTimeout(()=>{
            $('.network_toast').addClass('none')
          },1500)
          return
        }

        const isError = (
          this.form["invoiceType"] !== "增值税普通发票【个人】"
            ? [
                this.validator($(".input[field=invoiceTitle]")),
                this.validator($(".input[field=taxpayerId]")),
                this.validator($(".input[field=email]")),
              ]
            : [
                this.validator($(".input[field=invoiceTitle]")),
                this.validator($(".input[field=email]")),
              ]
        ).find((item) => item);
        if (isError) return;
        const html = `
          <li class="item">
          <span class="label">抬头类型:</span>
          <span class="value">${this.form["invoiceType"]}</span>
        </li>
        <li class="item">
          <span class="label">发票抬头:</span>
          <span class="value">${this.form["invoiceTitle"]}</span>
        </li>
        ${
          this.form["invoiceType"] !== "增值税普通发票【个人】"
            ? `<li class="item">
            <span class="label">发票税号:</span>
            <span class="value">${this.form["taxpayerId"]}</span>
          </li>`
            : ``
        }
        <li class="item">
          <span class="label">邮箱地址:</span>
          <span class="value">${this.form["email"]}</span>
        </li>
        `;
        $(".confirmInfo .info").html(html);
        this.showDialog(".confirmInfo");
      });

    $(".cancel")
      .off()
      .on("click", () => {
        this.hideDialog(".confirmInfo");
      });

    $(".input")
      .off()
      .on("input", (e) => {
        const el = $(e.target);
        this.validator(el);
      });
  };
  new Index();
});